#include "StdAfx.h"
#include "ConfigBaseDlg.h"


IMPLEMENT_DYNAMIC(CConfigBaseDlg, CDialog)
CConfigBaseDlg * CConfigBaseDlg::m_pDlgCurrent=NULL;

CConfigBaseDlg::CConfigBaseDlg(UINT nResourceID,CWnd* pParent /*=NULL*/)
: CDialog(nResourceID,pParent)
{
	//m_pFontDialog=NULL;
}

CConfigBaseDlg::~CConfigBaseDlg()
{
    ASSERT(m_ClickAssociateInfos.empty());
}

BEGIN_MESSAGE_MAP(CConfigBaseDlg, CDialog)
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

void CConfigBaseDlg::OnOK()
{
	CDialog::OnOK();
	return;

	
}
BOOL CConfigBaseDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_KEYDOWN)
	{
		if(pMsg->wParam == VK_ESCAPE)
		{
			return TRUE;
		}
		else if(pMsg->wParam == VK_RETURN)
		{			

			return TRUE;
		}
	}
	else if(pMsg->message == WM_CLOSE)
	{
		OnOK();
		return TRUE;
	}
	else if(pMsg->message == WM_LBUTTONDOWN)
	{
		if (CheckClickAssociateInfo(pMsg->pt))
		{
			return TRUE;
		}
	}
	return __super::PreTranslateMessage(pMsg);
}

void CConfigBaseDlg::OnCancel()
{
	CDialog::OnCancel();
	return;

	
}

BOOL CConfigBaseDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetWindowPos(0, 0, 35, 477, 278, SWP_NOZORDER);


	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) 
	{
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else 
	{
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	// LosdSkin()   ׸    .
	//  ׸ ϱ ؼ SetWindowsTheme  ̿ؾ .
	pSkinManager->ApplyWindow(GetSafeHwnd());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("ConfigDlg.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CConfigBaseDlg::ShowChild()
{
	if(m_pDlgCurrent == this)
	{
		return;
	}
	ShowWindow(SW_SHOW);
	if(m_pDlgCurrent)
		m_pDlgCurrent->ShowWindow(SW_HIDE);
	m_pDlgCurrent = this;
}

void CConfigBaseDlg::OnDestroy()
{
	for(ClickAssociateInfoContainer::iterator iter = m_ClickAssociateInfos.begin();
		iter != m_ClickAssociateInfos.end();
		++iter)
	{
		ClickAssociateInfo* pInfo = *iter;
		delete pInfo;
	}
	m_ClickAssociateInfos.clear();

	CDialog::OnDestroy();

	//if(m_pFontDialog && m_pFontDialog->GetSafeHwnd())
	//{
	//	m_pFontDialog->EndDialog(IDCANCEL);
	//	m_pFontDialog = NULL;
	//}

	if(m_pDlgCurrent == this)
	{
		m_pDlgCurrent=NULL;
	}
}

BOOL CConfigBaseDlg::OnEraseBkgnd(CDC* pDC)
{
	
	CWnd* pChild=GetWindow(GW_CHILD);
	while(pChild)
	{
		if(pChild->IsKindOf(RUNTIME_CLASS(CEdit)) || pChild->IsKindOf(RUNTIME_CLASS(CRichEditCtrl)) ||pChild->IsKindOf(RUNTIME_CLASS(CListCtrl)) || pChild->IsKindOf(RUNTIME_CLASS(CComboBox))||pChild->IsKindOf(RUNTIME_CLASS(CSpinButtonCtrl)))
		{
			if(pChild->IsWindowVisible())
			{
				CRect rcEdit(0, 0, 0, 0);
				pChild->GetWindowRect(rcEdit);
				ScreenToClient(rcEdit);

				rcEdit.InflateRect(1,1);
				rcEdit.OffsetRect(0, 0);
				CPen penEditBox;
				penEditBox.CreatePen(PS_SOLID,1,RGB(201,201,201));
				CPen *pOldPen= pDC->SelectObject(&penEditBox);
				pDC->Rectangle(rcEdit);
				pDC->SelectObject(pOldPen);
			}
		}

		pChild=pChild->GetWindow(GW_HWNDNEXT);
	}

	return TRUE;
}


void  CConfigBaseDlg::AddClickAssociateInfo(CButton* pButton, const CRect& rcRange)
{
	ClickAssociateInfo*	pInfo = new ClickAssociateInfo;
	ASSERT(pInfo);
	if (pInfo)
	{
		pInfo->pButton = pButton;
		pInfo->rcRange = rcRange;
		m_ClickAssociateInfos.push_back(pInfo);
	}
}//lint !e429

void CConfigBaseDlg::ToggleAssociateButton(CButton* pAssociateButton)
{
	ASSERT(pAssociateButton);
	if (pAssociateButton && pAssociateButton->IsWindowVisible() && pAssociateButton->IsWindowEnabled())
	{
		CNMImgCheckButton* pCheckButton = dynamic_cast<CNMImgCheckButton*>(pAssociateButton);
		if (pCheckButton)
		{
			//CNMImgCheckButton override NONE-virtual SetCheck and GetCheck function
			pCheckButton->SendMessage(BM_CLICK, 0, 0);
		}
		else
		{
			CNMImgRadioButton* pRadioButton = dynamic_cast<CNMImgRadioButton*>(pAssociateButton);
			if (pRadioButton)
			{
				//avoid show message box in CConfigMemo::OnBnClickedRadioChatBubble when already selected
				if (pRadioButton->GetCheck() != BST_CHECKED)
				{
					pRadioButton->SendMessage(BM_CLICK, 0, 0L);
				}
			}
			else
			{
				ASSERT(!TEXT("CAN NOT find Associate Button")); //lint !e506
			}
		}
	}
}
BOOL CConfigBaseDlg::CheckClickAssociateInfo(const CPoint& pt)
{
	BOOL bFound = FALSE;
	CPoint ptClient = pt;
	ScreenToClient(&ptClient);
	for (ClickAssociateInfoContainer::iterator iter = m_ClickAssociateInfos.begin();
		iter != m_ClickAssociateInfos.end();
		++iter)
	{
		ClickAssociateInfo* pInfo = *iter;
		ASSERT(pInfo);
		if (pInfo)
		{
			if(::PtInRect(&pInfo->rcRange, ptClient))
			{
				bFound = TRUE;
				ToggleAssociateButton(pInfo->pButton);
				break;
			}
		}
	}

	return bFound;
}
